@ECHO OFF
REM +-----------------------------------------------------------------+
REM |                  DON'T REMOVE THIS LINES                        |
REM |                                                                 |
REM | Author:      Ralf Weik                                          |
REM | Source from: awalon.de (http://www.awalon.de)                   |
REM | Mail:        software@awalon.de                                 |
REM | Programname: Backupscript                                       |
REM | Version:     1.0                                                |
REM +-----------------------------------------------------------------+
REM | Copyright (c) 2004-2005, Ralf Weik                              |
REM | All rights reserved.                                            |
REM |                                                                 |
REM | Redistribution and use in source and binary forms, with or      |
REM | without modification, are permitted provided that the following |
REM | conditions are met:                                             |
REM |                                                                 |
REM | * Redistributions of source code must retain the above          |
REM |   copyright notice, this list of conditions and the following   |
REM |   disclaimer.                                                   |
REM | * Redistributions in binary form must reproduce the above       |
REM |   copyright notice, this list of conditions and the following   |
REM |   disclaimer in the documentation and/or other materials        |
REM |   provided with the distribution.                               |
REM |                                                                 |
REM | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND           |
REM | CONTRIBUTOR "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,      |
REM | INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        |
REM | MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        |
REM | DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            |
REM | CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    |
REM | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    |
REM | NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    |
REM | LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        |
REM | HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       |
REM | CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    |
REM | OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  |
REM | EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              |
REM +-----------------------------------------------------------------+
REM | It is a free product!                                           |
REM | You can use it for free.                                        |
REM +-----------------------------------------------------------------+
REM | Configuration:                                                  |
REM | see section named ":SET_VAR" (line 74)                          |
REM +-----------------------------------------------------------------+
REM | WENN KEINE DATEIEN KOPIERT WERDEN, BITTE DIE ZEILEN 111 - 114   |
REM | BZW. 160 - 163 BEACHTEN.                                        |
REM | AUS LIZENZTECHNISCHEN GRNDEN KANN DIE DATEI ROBOCOPY.EXE NICHT |
REM | MITGELIEFERT WERDEN.                                            |
REM +-----------------------------------------------------------------+

:CHECKPARM
REM parameter pruefen
IF "%1" == ""         GOTO SHOWHELP
IF "%2" == ""         GOTO SHOWHELP

:CHECKSHOWHELP
REM Wird Hilfe gewuenscht
IF "%1" == "/?"       GOTO SHOWHELP
IF "%1" == "--help"   GOTO SHOWHELP


:CHECKMODE
REM Modus pruefen und ggf. Standardmodus setzen
IF "%3" == ""         GOTO DEFAULTMODE
SET MO=%3
GOTO SET_VAR
:DEFAULTMODE
REM Standardmodus setzen (vollstaendiges Backup)
SET MO=A
GOTO SET_VAR


:SET_VAR
REM Variablen definieren
SET NO_FULL_MAX=3
SET NO_DELTA_MAX=7
SET NO_FULL_CURRENT=0
SET NO_DELTA_CURRENT=0
SET DEST_BASE=%2\Gen
SET DEST_FULL=\Full
SET DEST_DELTAS=\Deltas
SET DEST_DELTA=%DEST_DELTAS%\Delta

REM Aktuelle Generation ermitteln
SET /A I=0
:SET_VAR_REP_FULL
SET /A I=%I%+1
IF EXIST "%DEST_BASE%%I%" SET NO_FULL_CURRENT=%I%
IF NOT "%I%" == "%NO_FULL_MAX%" GOTO SET_VAR_REP_FULL

REM Aktuelles Delta ermitteln
SET /A I=0
:SET_VAR_REP_DELTA
SET /A I=%I%+1
IF EXIST "%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTA%%I%" SET NO_DELTA_CURRENT=%I%
IF NOT "%I%" == "%NO_DELTA_MAX%" GOTO SET_VAR_REP_DELTA
:SET_VAR_END


REM Zielverzeichnis anlegen und Daten sichern
IF "%MO%" == "A"        GOTO COMPLETE
IF "%MO%" == "Alles"    GOTO COMPLETE
IF "%MO%" == "D"        GOTO CHANGES
IF "%MO%" == "Delta"    GOTO CHANGES
IF "%MO%" == "AR"       GOTO COMPLETE_RUN
IF "%MO%" == "AllesRun" GOTO COMPLETE_RUN
IF "%MO%" == "DR"       GOTO CHANGES_RUN
IF "%MO%" == "DeltaRun" GOTO CHANGES_RUN
GOTO SHOWHELP


:COMPLETE
rem Alles
ECHO.
ECHO Komplette Sicherung wird gestartet ([Strg+C] zum Abbrechen)
PAUSE
:COMPLETE_RUN
ECHO Starte Komplettsicherung...
REM Loesche aelteste komplette Sicherung (Generation1)
IF "%NO_FULL_CURRENT%" == "%NO_FULL_MAX%" GOTO COMPLETE_REP_START
SET /A I=%NO_FULL_CURRENT%+1
GOTO COMPLETE_NEW

REM Generationen verschieben
:COMPLETE_REP_START
RMDIR /S /Q "%DEST_BASE%1"
SET /A I=0
SET /A J=1
:COMPLETE_REP
SET /A I=%I%+1
SET /A J=%J%+1
IF EXIST "%DEST_BASE%%J%" MOVE /Y "%DEST_BASE%%J%" "%DEST_BASE%%I%"
IF NOT EXIST "%DEST_BASE%%I%" GOTO COMPLETE_NEW
IF NOT "%I%" == "%NO_FULL_MAX%" GOTO COMPLETE_REP
:COMPLETE_NEW
REM Zielverzeichnis anlegen
MKDIR "%DEST_BASE%%I%"

REM Logdatei erstellen und aktuelles Datum und Modus hinzufuegen
ECHO Komplettsicherung: %DATE% - %TIME%>>%2\backup.log
ECHO Komplettsicherung: %DATE% - %TIME%>%DEST_BASE%%I%\backup.log

REM Archivattribut entfernen
ECHO Markiere Dateien im Quellverzeichnis als archiviert...
ATTRIB -A %1\* /S /D

REM Daten sichern (Alle)
ECHO Sichere alle Dateien des Quellverzeichnisses...
REM Naechste Zeile fr die Verwendung von XCOPY aktivieren
REM XCOPY %1 %DEST_BASE%%I%%DEST_FULL% /E /V /G /H /R /O /X /Y /Z>>%DEST_BASE%%I%\backup.log
REM Naechste Zeile fr die Verwendung von ROBOCOPY aktivieren
ROBOCOPY %1 %DEST_BASE%%I%%DEST_FULL% /E /R:99 /W:1 /V /Z /ETA>>%DEST_BASE%%I%\backup.log

:COMPLETE_SHOW_LOG
REM Logdatei auf Bildschirm ausgeben
REM TYPE %DEST_BASE%%I%\backup.log|MORE

:COMPLETE_END
REM Fertig
GOTO FINISH


:CHANGES
rem Nur Delta
ECHO.
ECHO Sichert nur die Deltas der letzten Komplettsicherung ([Strg+C] zum Abbrechen)
PAUSE
:CHANGES_RUN
ECHO Starte Teilsicherung (Deltas der letzten Sicherung)...
REM Loesche aelteste Delta-Sicherung
IF "%NO_DELTA_CURRENT%" == "%NO_DELTA_MAX%" GOTO CHANGES_REP_START
SET /A I=%NO_DELTA_CURRENT%+1
GOTO CHANGES_NEW

REM Deltas verschieben
:CHANGES_REP_START
RMDIR /S /Q "%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTA%1"
SET /A I=0
SET /A J=1
:CHANGES_REP
SET /A I=%I%+1
SET /A J=%J%+1
IF EXIST "%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTA%%J%" MOVE /Y "%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTA%%J%" "%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTA%%I%"
IF NOT EXIST "%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTA%%I%\*" GOTO CHANGES_NEW
IF NOT "%I%" == "%NO_DELTA_MAX%" GOTO CHANGES_REP

:CHANGES_NEW
REM Zielverzeichnis anlegen
MKDIR "%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTA%%I%"

REM Logdateien erstellen und aktuelles Datum und Modus hinzufuegen
ECHO Teilsicherung: %DATE% - %TIME%>>%2\backup.log
ECHO Teilsicherung: %DATE% - %TIME%>>%DEST_BASE%%NO_FULL_CURRENT%\backup.log
ECHO Teilsicherung: %DATE% - %TIME%>%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTAS%\backup%I%.log

REM Daten sichern (Nur mit Archivattribut)
ECHO Sichere alle neuen und geaenderten Dateien des Quellverzeichnisses (Deltas)...
REM Naechste Zeile fr die Verwendung von XCOPY aktivieren
REM XCOPY %1 %DEST_BASE%%I%%DEST_FULL% /M /E /V /G /H /R /O /X /Y /Z>>%DEST_BASE%%I%\backup.log
REM Naechste Zeile fr die Verwendung von ROBOCOPY aktivieren
ROBOCOPY %1 %DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTA%%I% /E /R:99 /W:1 /V /M /Z /ETA>>%DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTAS%\backup%I%.log

:CHANGES_SHOW_LOG
REM Logdatei auf Bildschirm ausgeben
REM TYPE %DEST_BASE%%NO_FULL_CURRENT%%DEST_DELTAS%\backup%I%.log|MORE

:CHANGES_END
REM Fertig
GOTO FINISH


:SHOWHELP
REM Hilfe anzeigen
ECHO.
ECHO Syntax:
ECHO   backup.bat Quelle Ziel [Modus]
ECHO.
ECHO 	Quelle
ECHO 	  Verzeichnis/Laufwerk das gesichert werden soll
ECHO.
ECHO 	Ziel
ECHO 	  Gibt an wo die Sicherung gespeichert wird.
ECHO 	  (Es wird ein Unterverzeichnis mit dem aktuellen Datum erzeugt)
ECHO.
ECHO 	[Modus] (*R/*Run Batchmode ohne Bestaetiugung)
ECHO 	  Gibt die Art des Backups an:
ECHO 	   A/AR [Alles/AllesRun] * Standard *
ECHO 	    Alle Dateien und Verzeichnisse werden gesichert.
ECHO 	    (sollte min. einmal pro Monat erfolgen)
ECHO 	   D/DR [Delta/DeltaRun]
ECHO 	    Alle neuen, geaenderten Dateien und Verzeichnisse
ECHO 	    werden gesichert.
ECHO 	    (sollte min. einmal pro Monat erfolgen)
ECHO.
ECHO Beispiel:
ECHO   backup.bat D:\Daten K:\Backup A
ECHO   (sichert alle Dateien und Verzeichnisse von D:\Daten nach K:\Backup)
GOTO END


:FINISH
ECHO Die Sicherung ist beendet!
GOTO END


:END
REM Ende
REM EXIT